#include "handmade.h"

struct Win32OffscreenBuffer {
    BITMAPINFO info;
    void *memory;
    int width;
    int height;
    int bytesPerPixel;
    int pitch;
};

struct Win32WindowDimensions {
    int width;
    int height;
};

struct Win32SoundOutput {
    int samplesPerSecond;
    int16 toneVolume;
    uint32 runningSampleIndex;
    int bytesPerSample;
    int secondaryBufferSize;
    real32 tSine;
    int safetyBytes;
};

struct Win32DebugTimeMarker {
    DWORD playCursor;
    DWORD writeCursor;
};

struct Win32RecordedInput {
    int inputCount;
    GameInput *inputStream;
};

struct Win32State {
    HANDLE recordingHandle;
    uint32 inputRecordingIndex;
    HANDLE playbackHandle;
    uint32 inputPlayingIndex;
    uint64 gameMemoryTotalSize;
    void *gameMemoryBlock;
};
